// Copyright (c) 2012 Serge Goncharov
/* This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://sam.zoy.org/wtfpl/COPYING for more details. */

#include <stdio.h>

#define BUFSIZE	(1024*1024)



unsigned char  buffer[BUFSIZE];



void main (int argc, char **argv) {
  FILE  *f, *dump;
  unsigned char  c;
  int  i, j, sz;

  if ( argc<2 ) {
    printf ("Usage: bin2c <filename> ...\n  Dumps the contents of files as C-source hex arrays to file 'dump.c'.\n");
    return;
  }

  dump = fopen ("dump.c", "wb");
  if ( dump==NULL ) {
    printf ("Can't create dump file.\n");
    return;
  }

  for ( i=1; i<argc; ++i ) {
    f = fopen (argv[i], "rb");
    if ( f==NULL ) {
      printf ("Can't open file '%s'.\n", argv[i]);
      continue;
    }

    if ( i>1 )  fprintf (dump, "\n\n");
    for ( j=0; (c=argv[i][j])!=0; ++j ) {
      c = tolower(c);
      if ( !isalnum(c) )  c = '_';
      argv[i][j] = c;
    }
    fprintf (dump, "unsigned char %s[] = {", argv[i]);
    do {
      sz = fread (buffer, 1, BUFSIZE, f);
      for ( j=0; j<sz; ++j ) {
	if ( j%16==0 )  fprintf (dump, "\n ");
	fprintf (dump, " 0x%02X,", buffer[j]);
      }
    } while ( sz==BUFSIZE );
    fprintf (dump, "\n};");
    fclose (f);
  }

  fclose (dump);
}
